const _focuser = (_, options) => {
  requestAnimationFrame((_) => {
    let elem = document.querySelector(options.selector)
    if (elem) elem.focus()
  })
}
export const focuser = (selector) => [_focuser, { selector }]

const _dispatcher = (dispatch, options) => {
  dispatch(options.action, options.payload)
}
export const dispatcher = (action, payload) => [
  _dispatcher,
  { action, payload }
]

const _onhashchange = (dispatch, options) => {
  const handler = () => dispatch(options.action, location.hash)
  addEventListener("hashchange", handler)
  requestAnimationFrame(handler)
  return () => removeEventListener("hashchange", handler)
}

export const onhashchange = (action) => [_onhashchange, { action }]

const _persister = (dispatch, options) => {
  requestAnimationFrame((_) =>
    localStorage.setItem(options.key, JSON.stringify(options.watch))
  )
  return () => {}
}

export const persister = (key, watch) => [_persister, { key, watch }]

const _lsloader = (dispatch, options) => {
  let data = localStorage.getItem(options.key)
  if (!data) return
  data = JSON.parse(data)
  dispatch(options.action, data)
}
export const lsloader = (key, action) => [_lsloader, { key, action }]
